diff --git a/lib/hive/claude_launcher.rb b/lib/hive/claude_launcher.rb
index b6820a41..a2cc55cb 100644
--- a/lib/hive/claude_launcher.rb
+++ b/lib/hive/claude_launcher.rb
@@ -6,6 +6,7 @@ require "time"
 require "hive/agent_profiles"
 require "hive/agent_limit"
 require "hive/config"
+require "hive/events"
 require "hive/lock"
 require "hive/markers"
 require "hive/permission_scope"
@@ -19,6 +20,34 @@ module Hive
     SENTINEL_POLL_INTERVAL_SEC = 5
     SENTINEL_CAPTURE_BYTES = 8192
     PANE_LOG_CAPTURE_BYTES = 64 * 1024
+    # Minimum elapsed time after prompt-send before the ready-prompt
+    # fallback may arm. Guards the race where the pane still shows the
+    # idle ready prompt immediately after send_prompt, before Claude
+    # begins rendering. Tunable via HIVE_CLAUDE_TMUX_STOP_HOOK_FALLBACK_FLOOR_SEC.
+    STOP_HOOK_FALLBACK_FLOOR_SEC = 60
+    # Grace window after a stable ready prompt during which a late
+    # `.done` still wins the normal stop-hook path. Set to 0 to disable
+    # the ready-prompt fallback entirely (strict stop-hook-only mode).
+    # Tunable via HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC.
+    STOP_HOOK_GRACE_SEC = 15
+    # Consecutive ready-prompt observations (at sentinel cadence) before
+    # the grace window starts. Mirrors the "stable across polls" mapping
+    # of "Claude process exited 0" for interactive tmux sessions.
+    STOP_HOOK_READY_STABLE_POLLS = 2
+    # Consecutive capture_pane_tail TmuxError failures before reporting
+    # tmux_pane_unreadable (parity with wait_for_expected_output).
+    TMUX_PANE_UNREADABLE_STREAK = 3
+    # Consecutive `has-session` probe failures before treating tmux liveness
+    # as unreadable. A single timed-out/failed probe is transient evidence,
+    # not proof that the managed session terminated.
+    TMUX_SESSION_PROBE_ERROR_STREAK = 3
+    RESULT_JSON_STATUS_UNSET = Object.new.freeze
+    RESULT_JSON_IN_FLIGHT = Object.new.freeze
+    # Exact timeout message matched by StaleAgentHealer's
+    # FIX_CLAUDE_STOP_HOOK_MESSAGE special-case. Do not reword.
+    STOP_HOOK_TIMEOUT_MESSAGE = "claude stop hook did not signal completion".freeze
+    STOP_HOOK_SESSION_TERMINATED_MESSAGE =
+      "tmux_session_terminated before stop hook signaled completion".freeze
     # Shared-session reviewer sends re-call `prepare_claude_session!`
     # between each per-reviewer prompt; a 30s ceiling was too tight for
     # the legitimate case where the prior reviewer's response was still
@@ -76,6 +105,7 @@ module Hive
     CLAUDE_READY_PROMPT_LINE = /\A❯(?:[\p{Zs}\s]|\z)|(?:[\p{Zs}\s])❯\z/u.freeze
     CLAUDE_MENU_OPTION_LINE = /\A\s*❯\s*\d+\./.freeze
     CLAUDE_PROMPT_CHROME_LINE = /\A[\p{Zs}\s?+\-─━│┄┈┉┅┇┊┋┆┌┐└┘├┤┬┴┼═║╔╗╚╝╠╣╦╩╬╭╮╰╯╴╵╶╷╸╹╺╻╼╽╾╿]+\z/u.freeze
+    CLAUDE_RESPONSE_LINE_RE = /\A\s*[●⏺]\s*(?<body>.*?)\s*\z/u.freeze
     CLAUDE_PROMPT_CONTEXT_LINES = 12
     # Lines at the bottom of the current input region to inspect for the idle
     # caret. The scan is wide enough for separator/caret/separator/footer
@@ -515,8 +545,28 @@ module Hive
 
     def wait_until_session_exists!(runner)
       deadline = Time.now + session_ready_wait_timeout
-      until runner.session_exists?
-        raise Hive::AgentError, "tmux session #{runner.name} did not start" if Time.now >= deadline
+      last_probe_error = nil
+      loop do
+        begin
+          return if runner.session_exists?
+
+          last_probe_error = nil
+        rescue Hive::TmuxError => e
+          # `tmux has-session` can fail transiently while the server is
+          # starting. Keep the existing startup deadline as the authority
+          # instead of converting the first unreadable probe into a launch
+          # failure.
+          last_probe_error = e.message
+        end
+
+        if Time.now >= deadline
+          detail = if last_probe_error
+                     "; last liveness probe failed: #{last_probe_error}"
+                   else
+                     ""
+                   end
+          raise Hive::AgentError, "tmux session #{runner.name} did not start#{detail}"
+        end
 
         sleep 0.1
       end
@@ -669,6 +719,26 @@ module Hive
       current_lines.reject(&:empty?).last(CLAUDE_PROMPT_CONTEXT_LINES).join("\n")
     end
 
+    # Isolate Claude's final response line from a captured interactive pane.
+    # The pane necessarily ends with the current idle caret and footer chrome;
+    # callers that need the response itself must not treat that full tail as a
+    # structured final message.
+    def final_response_from_pane(pane)
+      lines = pane.each_line.map(&:rstrip)
+      prompt_index = lines.rindex do |line|
+        stripped = line.strip
+        stripped.match?(CLAUDE_READY_PROMPT_LINE) &&
+          !stripped.match?(CLAUDE_MENU_OPTION_LINE)
+      end
+      return "" unless prompt_index
+
+      lines[0...prompt_index].reverse_each do |line|
+        match = line.match(CLAUDE_RESPONSE_LINE_RE)
+        return match[:body].strip if match
+      end
+      ""
+    end
+
     def wait_for_terminal_marker(task, runner, timeout)
       deadline = Time.now + timeout
       last_sentinel_check = Time.at(0)
@@ -767,6 +837,8 @@ module Hive
       deadline = Time.now + timeout
       tmux_error_streak = 0
       last_tmux_error_msg = nil
+      session_probe_error_streak = 0
+      last_session_probe_error_msg = nil
       loop do
         output_available = expected_output_available?(expected_output)
         pane_tail = capture_limit_tail(runner)
@@ -778,7 +850,23 @@ module Hive
           }
         end
 
-        unless expected_output_session_alive?(runner)
+        session_alive = begin
+          alive = expected_output_session_alive?(runner)
+          session_probe_error_streak = 0
+          alive
+        rescue Hive::TmuxError => e
+          session_probe_error_streak += 1
+          last_session_probe_error_msg = e.message
+          if session_probe_error_streak >= TMUX_SESSION_PROBE_ERROR_STREAK
+            return {
+              status: :error,
+              error_message: "tmux_session_probe_unreadable: #{last_session_probe_error_msg}"
+            }
+          end
+          nil
+        end
+
+        if session_alive == false
           return { status: :ok, log_label: log_label } if output_available && File.exist?(done_path(task))
 
           return {
@@ -829,8 +917,6 @@ module Hive
       return true unless runner.respond_to?(:session_exists?)
 
       runner.session_exists?
-    rescue Hive::TmuxError
-      false
     end
 
     def capture_limit_tail(runner)
@@ -843,6 +929,21 @@ module Hive
 
     def wait_for_done_signal(task, runner, timeout, log_label)
       deadline = Time.now + timeout
+      started_at = Time.now
+      tmux_error_streak = 0
+      last_tmux_error_msg = nil
+      ready_streak = 0
+      grace_started_at = nil
+      last_ready_check_at = nil
+      session_probe_error_streak = 0
+      last_session_probe_error_msg = nil
+      floor_sec = stop_hook_fallback_floor_sec
+      grace_sec = stop_hook_grace_sec
+      # grace_sec == 0 disables the ready-prompt fallback (strict
+      # stop-hook-only mode). Session-gone / pane-unreadable arms stay
+      # active regardless — they make the mode stricter, not looser.
+      fallback_enabled = grace_sec.positive?
+
       loop do
         # A usage/credit wall stalls claude WITHOUT ever touching `.done`,
         # so this exit_code_only path (the default `claude`/tmux execute
@@ -864,41 +965,206 @@ module Hive
         end
 
         if File.exist?(done_path(task))
-          # The stop-hook touches `.done` even on `empty_stdin` /
-          # other non-success completions; the real status lives in
-          # `result.json`. Without this check, an exit_code_only
-          # caller (e.g. the Phase 4 fix agent) would see `:ok` for
-          # an errored claude run.
-          status = read_result_json_status(task)
-          if status == :ok
-            return { status: :ok, log_label: log_label }
-          elsif status
-            return { status: status, log_label: log_label,
-                     error_message: "claude reported #{status.inspect} via result.json" }
+          return done_signal_result(task, log_label, stop_hook_signal: :done_file)
+        end
+
+        # Session-gone (strict): a crashed/killed tmux session must not
+        # drain to the generic stop-hook timeout. When `.done` is present
+        # the branch above already returned (mirrors wait_for_expected_output
+        # ordering — honor the sentinel even if the session is gone).
+        session_alive = begin
+          alive = done_signal_session_alive?(runner)
+          session_probe_error_streak = 0
+          alive
+        rescue Hive::TmuxError => e
+          session_probe_error_streak += 1
+          last_session_probe_error_msg = e.message
+          if session_probe_error_streak >= TMUX_SESSION_PROBE_ERROR_STREAK
+            return {
+              status: :error,
+              error_message: "tmux_session_probe_unreadable: #{last_session_probe_error_msg}"
+            }
+          end
+          nil
+        end
+
+        if session_alive == false
+          return {
+            status: :error,
+            error_message: STOP_HOOK_SESSION_TERMINATED_MESSAGE
+          }
+        end
+
+        # Ready-prompt fallback + pane-unreadable detection sample at
+        # sentinel cadence so we do not thrash capture_pane on every
+        # short poll tick. Fallback requires: (a) past floor, (b) ≥N
+        # consecutive ready detections, (c) grace elapsed without `.done`.
+        if runner.respond_to?(:capture_pane_tail)
+          now = Time.now
+          if last_ready_check_at.nil? || (now - last_ready_check_at) >= sentinel_poll_interval
+            last_ready_check_at = now
+            begin
+              pane = runner.capture_pane_tail(bytes: SENTINEL_CAPTURE_BYTES)
+              tmux_error_streak = 0
+              if fallback_enabled &&
+                 claude_ready_prompt?(pane) &&
+                 (now - started_at) >= floor_sec
+                ready_streak += 1
+                grace_started_at = now if ready_streak >= STOP_HOOK_READY_STABLE_POLLS && grace_started_at.nil?
+              else
+                ready_streak = 0
+                grace_started_at = nil
+              end
+            rescue Hive::TmuxError => e
+              tmux_error_streak += 1
+              last_tmux_error_msg = e.message
+              ready_streak = 0
+              grace_started_at = nil
+              if tmux_error_streak >= TMUX_PANE_UNREADABLE_STREAK
+                return {
+                  status: :error,
+                  error_message: "tmux_pane_unreadable: #{last_tmux_error_msg}"
+                }
+              end
+            end
+          end
+
+          if grace_started_at && (Time.now - grace_started_at) >= grace_sec
+            # Late-hook race: re-check `.done` once more before accepting
+            # the fallback so a merely-late sentinel still wins.
+            if File.exist?(done_path(task))
+              return done_signal_result(task, log_label, stop_hook_signal: :done_file)
+            end
+
+            # The hook writes result.json before its EXIT trap publishes
+            # `.done`. If the final sentinel check races that write, a
+            # partial failed payload must not be mistaken for an absent
+            # result and accepted as fallback success. Leave the fallback
+            # armed and poll again so `.done` can publish the richer status.
+            result_status = read_result_json_status(task)
+            unless result_status.equal?(RESULT_JSON_IN_FLIGHT)
+              result = done_signal_result(
+                task, log_label,
+                stop_hook_signal: :missing,
+                completion_evidence: :ready_prompt,
+                result_json_status: result_status
+              )
+              emit_completion_fallback_event(
+                task: task,
+                runner: runner,
+                log_label: log_label,
+                floor_sec: floor_sec,
+                grace_sec: grace_sec
+              )
+              return result
+            end
           end
-          # No result.json on disk yet — the .done write may have
-          # raced the result write. Treat as completion since
-          # exit_code_only callers don't carry a richer contract.
-          return { status: :ok, log_label: log_label }
         end
 
         if Time.now >= deadline
-          return { status: :timeout, error_message: "claude stop hook did not signal completion" }
+          return { status: :timeout, error_message: STOP_HOOK_TIMEOUT_MESSAGE }
         end
 
         sleep [ poll_interval, deadline - Time.now ].min
       end
     end
 
+    # Translate `.done` / fallback completion into the caller envelope.
+    # `stop_hook_signal: :done_file` is the normal path; `:missing` is the
+    # ready-prompt fallback. `result.json` status (when present) still
+    # overrides `:ok` so a hook that wrote an error status before dying
+    # yields the richer failure.
+    def done_signal_result(task, log_label, stop_hook_signal:, completion_evidence: nil,
+                           result_json_status: RESULT_JSON_STATUS_UNSET)
+      status = if result_json_status.equal?(RESULT_JSON_STATUS_UNSET)
+                 read_result_json_status(task)
+               else
+                 result_json_status
+               end
+      base = { status: :ok, log_label: log_label, stop_hook_signal: stop_hook_signal }
+      base[:completion_evidence] = completion_evidence if completion_evidence
+
+      if status.equal?(RESULT_JSON_IN_FLIGHT)
+        {
+          status: :error,
+          log_label: log_label,
+          stop_hook_signal: stop_hook_signal,
+          error_message: "claude result.json is incomplete or unreadable after completion signal"
+        }.tap { |h| h[:completion_evidence] = completion_evidence if completion_evidence }
+      elsif status.nil? || status == :ok
+        base
+      else
+        {
+          status: :error,
+          reported_status: status,
+          log_label: log_label,
+          stop_hook_signal: stop_hook_signal,
+          error_message: "claude reported #{status.inspect} via result.json"
+        }.tap { |h| h[:completion_evidence] = completion_evidence if completion_evidence }
+      end
+    end
+
+    def done_signal_session_alive?(runner)
+      return true unless runner.respond_to?(:session_exists?)
+
+      runner.session_exists?
+    end
+
+    def stop_hook_fallback_floor_sec
+      Float(tmux_env("STOP_HOOK_FALLBACK_FLOOR_SEC", STOP_HOOK_FALLBACK_FLOOR_SEC.to_s))
+    end
+
+    def stop_hook_grace_sec
+      Float(tmux_env("STOP_HOOK_GRACE_SEC", STOP_HOOK_GRACE_SEC.to_s))
+    end
+
+    # Best-effort WARN audit record when the ready-prompt fallback accepts
+    # completion without `.done`. Event-write failure must not alter the
+    # spawn result envelope (parity with Events.emit's rescue posture).
+    def emit_completion_fallback_event(task:, runner:, log_label:, floor_sec:, grace_sec:)
+      return unless task.respond_to?(:folder) && task.folder
+
+      session = if runner.respond_to?(:name)
+                  runner.name
+                else
+                  "unknown"
+                end
+      result_present = File.exist?(result_path(task)) && File.size(result_path(task)).positive?
+      message = [
+        "reason=stop_hook_missing_after_ready_prompt",
+        "sentinel=#{done_path(task)}",
+        "session=#{session}",
+        "floor_sec=#{floor_sec}",
+        "grace_sec=#{grace_sec}",
+        "result_json=#{result_present ? 'present' : 'absent'}",
+        "evidence=ready_prompt"
+      ].join(" ")
+
+      Hive::Events.emit(
+        task_folder: task.folder,
+        slug: task.respond_to?(:slug) ? task.slug : File.basename(task.folder.to_s),
+        stage: task.respond_to?(:stage_name) ? "#{task.stage_index}-#{task.stage_name}" : "unknown",
+        event_type: :claude_completion_fallback,
+        agent: log_label,
+        message: message
+      )
+    rescue StandardError => e
+      warn "[hive.claude_launcher] failed to emit claude_completion_fallback: #{e.class}: #{e.message}"
+      nil
+    end
+
     # Read `result.json` (if present) and translate `status` into the
-    # caller's symbol vocabulary. Unknown / unparseable shapes return
-    # nil so the caller can fall through to its default success path.
+    # caller's symbol vocabulary. Absence (or a valid hook payload without a
+    # status) returns nil. A present but empty, partial, unreadable, or
+    # non-object payload returns RESULT_JSON_IN_FLIGHT so the ready-prompt
+    # fallback waits for the hook's EXIT trap instead of accepting success.
     def read_result_json_status(task)
       path = result_path(task)
-      return nil unless File.exist?(path) && File.size(path).positive?
+      payload = File.read(path)
+      return RESULT_JSON_IN_FLIGHT if payload.empty?
 
-      data = JSON.parse(File.read(path))
-      return nil unless data.is_a?(Hash)
+      data = JSON.parse(payload)
+      return RESULT_JSON_IN_FLIGHT unless data.is_a?(Hash)
 
       raw = data["status"].to_s
       case raw
@@ -906,8 +1172,10 @@ module Hive
       when "" then nil
       else raw.to_sym
       end
-    rescue JSON::ParserError, SystemCallError, IOError
+    rescue Errno::ENOENT
       nil
+    rescue JSON::ParserError, SystemCallError, IOError
+      RESULT_JSON_IN_FLIGHT
     end
 
     def poll_interval
diff --git a/lib/hive/events.rb b/lib/hive/events.rb
index 31ecc07a..f8bca816 100644
--- a/lib/hive/events.rb
+++ b/lib/hive/events.rb
@@ -14,6 +14,7 @@ module Hive
       round_waiting
       round_complete
       clean_exit_auto_committed
+      claude_completion_fallback
     ].freeze
 
     STATUS_TAIL_LINES = 20
diff --git a/lib/hive/scripts/stop_hook.sh b/lib/hive/scripts/stop_hook.sh
index 086433f0..fed6f178 100755
--- a/lib/hive/scripts/stop_hook.sh
+++ b/lib/hive/scripts/stop_hook.sh
@@ -3,16 +3,24 @@ set -eu
 
 : "${HIVE_TASK_STAGE_DIR:?HIVE_TASK_STAGE_DIR required}"
 
-# Buffer stdin first so an empty payload doesn't silently produce a
-# zero-byte result.json — that file is forensic evidence, and an empty
-# write is indistinguishable from "hook ran but Claude Code passed no
-# data". If stdin is empty, write an explicit sentinel JSON object
-# instead so the operator can tell the difference.
+# Always touch `.done` on exit so a failure writing result.json cannot
+# leave the orchestrator waiting for a sentinel that never arrives.
+# Happy-path ordering is preserved: result.json is written first (below),
+# then the EXIT trap touches `.done` after the script body finishes (or
+# aborts). Callers that consult result.json when present still see the
+# richer status; callers that only need completion still wake up.
+done_path="${HIVE_TASK_STAGE_DIR}/.done"
+touch_done() {
+  touch "$done_path" || true
+}
+trap touch_done EXIT
+
+# Stream stdin directly so every byte, including trailing newlines, is
+# preserved in result.json. A zero-byte payload is still replaced with an
+# explicit sentinel JSON object so the operator can distinguish "hook ran but
+# Claude Code passed no data" from a missing hook.
 result_path="${HIVE_TASK_STAGE_DIR}/result.json"
-payload=$(cat)
-if [ -z "$payload" ]; then
+cat > "$result_path"
+if [ ! -s "$result_path" ]; then
   printf '%s\n' '{"hive_stop_hook":"empty_stdin"}' > "$result_path"
-else
-  printf '%s' "$payload" > "$result_path"
 fi
-touch "${HIVE_TASK_STAGE_DIR}/.done"
diff --git a/lib/hive/stages/review.rb b/lib/hive/stages/review.rb
index 7ca0fb20..c4e5ffba 100644
--- a/lib/hive/stages/review.rb
+++ b/lib/hive/stages/review.rb
@@ -69,6 +69,10 @@ module Hive
       # next pass's fix prompt and over-amplify guardrail findings.
       ESCALATION_Q_RE = /^\s*###\s+Q(\d+)\.\s*(.*?)\s*$/.freeze
       ESCALATION_A_RE = /^\s*###\s+A(\d+)\.\s*$/.freeze
+      REVIEWER_FINDING_LINE_RE = /^\s*-\s+\[[ xX]\]\s+/.freeze
+      REVIEWER_SEVERITY_HEADER_RE = /^\s*##\s+(?:High|Medium|Nit)\b/i.freeze
+      REVIEWER_NO_FINDINGS_RE = /^\s*No findings\.\s*$/i.freeze
+      AFFIRMATIVE_NO_CHANGE_MESSAGE_RE = /\A(?:no changes needed|nothing to (?:fix|change)|no code changes(?: needed)?)\.?\z/i.freeze
 
       # Per-pass sentinel: `reviews/fix-success-NN.md` is written after
       # a pass's Phase 4 fix succeeds (or Phase 2 produced zero findings
@@ -581,8 +585,18 @@ module Hive
           ]
           before_fix_sha = Hive::ProtectedFiles.snapshot(task.folder, protected_set)
           before_fix_head = git_head(worktree_path)
+          expected_reviewer_artifacts = pass_reviewer_artifact_paths(ctx_pass)
 
           fix_result = spawn_fix_agent(task, cfg, ctx_pass, accepted: accepted)
+          # Tmux exit_code_only may complete via ready-prompt fallback when
+          # the Stop hook never writes `.done`. Corroborate before treating
+          # that as success; otherwise demote to the exact stop-hook timeout
+          # so StaleAgentHealer's special-case still matches.
+          fix_result = apply_fix_completion_fallback_gate!(
+            task, ctx_pass, fix_result,
+            before_fix_head: before_fix_head,
+            expected_artifacts: expected_reviewer_artifacts
+          )
           after_fix_sha = Hive::ProtectedFiles.snapshot(task.folder, protected_set)
           after_fix_head = git_head(worktree_path)
 
@@ -1812,6 +1826,179 @@ module Hive
         File.write(path, body)
       end
 
+      # When the shared launcher returns :ok with stop_hook_signal: :missing,
+      # require caller-side corroboration (worktree + artifacts + change or
+      # no-change evidence + no open escalations) before the fix phase
+      # continues. Failure preserves the exact stop-hook timeout message.
+      def apply_fix_completion_fallback_gate!(task, ctx, fix_result, before_fix_head:, expected_artifacts: nil)
+        return fix_result unless fix_result.is_a?(Hash)
+        return fix_result unless fix_result[:status] == :ok &&
+                                 fix_result[:stop_hook_signal] == :missing
+
+        evidence = fix_fallback_corroboration_evidence(
+          ctx, fix_result, before_fix_head,
+          expected_artifacts: expected_artifacts
+        )
+        if evidence[:ok]
+          emit_fix_completion_fallback_event(task, ctx, evidence)
+          return fix_result
+        end
+
+        {
+          status: :timeout,
+          error_message: Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE,
+          log_label: fix_result[:log_label],
+          stop_hook_signal: :missing,
+          completion_evidence: fix_result[:completion_evidence],
+          fallback_corroboration: :failed,
+          fallback_corroboration_reason: evidence[:reason]
+        }
+      end
+
+      def fix_fallback_corroboration_evidence(ctx, fix_result, before_fix_head, expected_artifacts: nil)
+        worktree_path = ctx.worktree_path
+        status = worktree_status(worktree_path)
+        if status.is_a?(Array)
+          return { ok: false, reason: "worktree_unreadable", status: status }
+        end
+
+        artifacts = expected_artifacts || pass_reviewer_artifact_paths(ctx)
+        unless artifacts_parseable?(artifacts)
+          return { ok: false, reason: "artifacts_missing_or_unreadable", artifacts: artifacts }
+        end
+
+        if count_escalations(ctx).positive?
+          return { ok: false, reason: "unresolved_escalations", artifacts: artifacts }
+        end
+
+        after_head = git_head(worktree_path)
+        head_advanced = descendant_commit?(worktree_path, before_fix_head, after_head)
+        dirty = status == :dirty
+        no_change = fix_no_change_evidence?(ctx, fix_result, artifacts: artifacts)
+
+        unless head_advanced || dirty || no_change
+          return {
+            ok: false,
+            reason: "no_change_evidence",
+            artifacts: artifacts,
+            head: after_head,
+            before_head: before_fix_head,
+            worktree: status
+          }
+        end
+
+        {
+          ok: true,
+          reason: head_advanced ? "head_advanced" : (dirty ? "worktree_dirty" : "no_change"),
+          artifacts: artifacts,
+          head: after_head,
+          before_head: before_fix_head,
+          worktree: status,
+          no_change: no_change
+        }
+      end
+
+      def fix_no_change_evidence?(ctx, fix_result, artifacts: nil)
+        return true if explicit_no_change_message?(fix_result)
+
+        finding_lines = pass_finding_checkbox_lines(ctx, artifacts: artifacts)
+        return false if finding_lines.empty?
+
+        # All findings for the pass are accepted ([x]); none remain unchecked.
+        finding_lines.all? { |line| line.match?(/^\s*-\s+\[x\]\s+/i) }
+      end
+
+      def explicit_no_change_message?(fix_result)
+        return false unless fix_result.is_a?(Hash)
+
+        msg = fix_result[:final_message].to_s.strip
+        return false unless msg.valid_encoding?
+
+        if fix_result[:final_message_source].to_s == "plain"
+          msg = Hive::ClaudeLauncher.final_response_from_pane(msg)
+        end
+        msg.match?(AFFIRMATIVE_NO_CHANGE_MESSAGE_RE)
+      end
+
+      def descendant_commit?(worktree_path, before_head, after_head)
+        return false if before_head.to_s.empty? || after_head.to_s.empty?
+        return false if before_head == after_head
+
+        Hive::GitOps.new(worktree_path).ancestor?(before_head, after_head)
+      rescue Hive::GitError
+        false
+      end
+
+      def pass_reviewer_artifact_paths(ctx)
+        pass_suffix = format("%02d", ctx.pass)
+        Dir[File.join(ctx.task_folder, "reviews", "*-#{pass_suffix}.md")]
+          .select { |path| reviewer_file?(File.basename(path)) }
+          .sort
+      end
+
+      def artifacts_parseable?(paths)
+        return false if paths.empty?
+
+        paths.all? { |path| reviewer_artifact_parseable?(path) }
+      end
+
+      def reviewer_artifact_parseable?(path)
+        return false unless File.file?(path) && File.readable?(path)
+
+        lines = File.readlines(path, chomp: true)
+        return false if lines.empty? || lines.all? { |line| line.strip.empty? }
+        return true if lines.any? { |line| line.match?(REVIEWER_FINDING_LINE_RE) }
+
+        lines.each_index.any? do |index|
+          lines[index].match?(REVIEWER_SEVERITY_HEADER_RE) &&
+            lines[(index + 1)..].to_a.take_while { |line| !line.match?(REVIEWER_SEVERITY_HEADER_RE) }
+                 .any? { |line| line.match?(REVIEWER_NO_FINDINGS_RE) }
+        end
+      rescue SystemCallError, IOError, EncodingError, ArgumentError
+        false
+      end
+
+      def pass_finding_checkbox_lines(ctx, artifacts: nil)
+        lines = []
+        (artifacts || pass_reviewer_artifact_paths(ctx)).each do |path|
+          File.readlines(path).each do |line|
+            next unless line.match?(REVIEWER_FINDING_LINE_RE)
+            next if line.match?(/^\s*-\s+\[[ xX]\]\s+(RESOLVED\/NO-FIX|RESOLVED|NO-FIX|SUPPRESSED)\b/i)
+
+            lines << line
+          end
+        rescue SystemCallError, IOError
+          next
+        end
+        lines
+      end
+
+      def emit_fix_completion_fallback_event(task, ctx, evidence)
+        artifacts = Array(evidence[:artifacts]).map { |p| File.basename(p) }.join(",")
+        message = [
+          "phase=fix",
+          "pass=#{format('%02d', ctx.pass)}",
+          "reason=#{evidence[:reason]}",
+          "head=#{evidence[:head]}",
+          "before_head=#{evidence[:before_head]}",
+          "worktree=#{evidence[:worktree]}",
+          "no_change=#{evidence[:no_change] ? 'true' : 'false'}",
+          "artifacts=#{artifacts.empty? ? 'none' : artifacts}",
+          "slug=#{task.slug}"
+        ].join(" ")
+
+        Hive::Events.emit(
+          task_folder: task.folder,
+          slug: task.slug,
+          stage: "6-review",
+          event_type: :claude_completion_fallback,
+          agent: "review-fix-pass#{format('%02d', ctx.pass)}",
+          message: message
+        )
+      rescue StandardError
+        nil
+      end
+
       def spawn_fix_agent(task, cfg, ctx, accepted:)
         profile_name = cfg.dig("review", "fix", "agent") || "claude"
         profile = Hive::AgentProfiles.lookup(profile_name, cfg: cfg)
diff --git a/lib/hive/tmux_runner.rb b/lib/hive/tmux_runner.rb
index 0133c160..248737c2 100644
--- a/lib/hive/tmux_runner.rb
+++ b/lib/hive/tmux_runner.rb
@@ -59,10 +59,11 @@ module Hive
     end
 
     def session_exists?
-      _out, _err, status = capture_tmux("has-session", "-t", @name)
-      status.success?
-    rescue Hive::TmuxError
-      false
+      _out, err, status = capture_tmux("has-session", "-t", @name)
+      return true if status.success?
+      return false if tmux_server_unavailable?(err)
+
+      raise CommandFailed, "tmux has-session failed: #{err.strip}"
     end
 
     def send_prompt(text)
